from . import senders
from . import config

class CIProcessor(object):

    def __init__(self, log, sender=None):
        if sender is None:
            self.sender = senders.get_sender(config.sender_type)
        else:
            self.sender = sender

        self.sender = self.sender()

    def process(self, msg):
        """ Extract most of the overlapping information and let the
        sub-class complement it if they want.
        """

        data = {
            "msg_id": msg['msg_id'],
            "build_id": msg['msg']['build_id'],
            "build_url": msg['msg']['build_url'],
            "branch":  msg['msg']['branch'],
            "ref": msg['msg']['ref'],
            "rev":  msg['msg']['rev'],
            "repo": msg['msg']['repo'],
            "namespace": msg['msg']['namespace'],
            "username": msg['msg']['username'],
            "status": msg['msg']['status'],
        }

        if 'topic' in msg['msg']:
            data['topic'] = msg['msg']['topic']
        elif 'ci_topic' in msg['msg']:
            data['topic'] = msg['msg']['ci_topic']

        for key in ['package_url', 'compose_url', 'nvr', 'original_spec_nvr']:
            if key in msg['msg']:
                data[key] = msg['msg'][key]

        return data


    def send(self, data):
        self.sender.send(data)
