from resultsdb_listener import pipeline_image_test_smoke_complete

example_message = {
  "i": 1,
  "timestamp": 1496382015, 
  "msg_id": "2017-f2b46ca1-1b07-4539-8d86-f7d3cb1b5934",
  "crypto": "x509", 
  "topic": "org.centos.prod.ci.pipeline.image.test.smoke.complete",
  'msg': {
        "CI_TYPE": "custom",
        "CI_NAME": "ci-pipeline-ostree-image-boot-sanity",
        "topic": "org.centos.prod.ci.pipeline.image.test.smoke.complete",
        "build_id": "82", 
        "build_url": "https://ci.centos.org/job/cci-pipeline-ostree-image-boot-sanity/82/",
        "image_url": "http://artifacts.ci.centos.org/artifacts/fedora-atomic/f26/images/fedora-atomic-26.85-c2dcff5e8d4637a.qcow2",
        "image_name": "fedora-atomic-26.85-c2dcff5e8d4637a.qcow2",
        "type": "qcow2",
        "compose_url": "http://artifacts.ci.centos.org/artifacts/fedora-atomic/f26/ostree",
        "compose_rev": "c2dcff5e8d4637a6cb19dd0f3e867b48b3d3b6fa0528dd2d64de23169f9221df",
        "branch": "f26",
        "ref": "fedora/f26/x86_64/atomic-host",
        "rev": "N/A",
        "repo": "N/A",
        "namespace": "rpms", 
        "username": "fedora-atomic",
        "test_guidance": "<comma-separated-list-of-test-suites-to-run>",
        "message-content": "",
        "status": "<SUCCESS/FAILURE/ABORTED/ABORTED>"
  }
}


class TestPipelineImageTestSmokeComplete(object):
    def test_exists(self):
        pipeline_image_test_smoke_complete.PipelineImageTestSmokeCompleteProcessor(None)

    def test_parse_example_message(self):
        test_listener = pipeline_image_test_smoke_complete.PipelineImageTestSmokeCompleteProcessor(None)
        test_data = test_listener.process(example_message)

        assert test_data['msg_id'] == example_message['msg_id']
        assert test_data['topic'] == example_message['msg']['topic']
        assert test_data['build_id'] == example_message['msg']['build_id']
        assert test_data['build_url'] == example_message['msg']['build_url']
        assert test_data['compose_url'] == example_message['msg']['compose_url']
        assert test_data['branch'] == example_message['msg']['branch']
        assert test_data['ref'] == example_message['msg']['ref']
        assert test_data['rev'] == example_message['msg']['rev']
        assert test_data['repo'] == example_message['msg']['repo']
        assert test_data['namespace'] == example_message['msg']['namespace']
        assert test_data['username'] == example_message['msg']['username']
