from resultsdb_listener import pipeline_package_complete

example_message = { 
  "i": 1,
  "timestamp": 1496382015, 
  "msg_id": "2017-f2b46ca1-1b07-4539-8d86-f7d3cb1b5934", 
  "crypto": "x509", 
  "topic": "org.centos.prod.ci.pipeline.package.complete",
  'msg': { 
        "CI_TYPE": "custom", 
        "CI_NAME": "ci-pipeline-duffy-allocate-new",
        "topic": "org.centos.prod.ci.pipeline.package.complete",
        "build_id": "79", 
        "build_url": "https://ci.centos.org/job/ci-pipeline-duffy-allocate-new/79/",
        "package_url": "http://artifacts.ci.centos.org/artifacts/fedora-atomic/rawhide/repo/perl_repo/perl-5.26.0-392.fc27.x86_64.rpm",
        "branch": "rawhide",
        "ref": "fedora/rawhide/x86_64/atomic-host",
        "rev": "0546fa18041a8ca223f4f441dc1868fc81ddce0f", 
        "repo": "perl", 
        "namespace": "rpms", 
        "username": "fedora-atomic", 
        "test_guidance": "''",
        "message-content": "",
        "status": "<SUCCESS/FAILURE/ABORTED>"
  }
}


class TestPipelinePackageComplete(object):
    def test_exists(self):
        pipeline_package_complete.PipelinePackageCompleteProcessor(None)

    def test_parse_example_message(self):
        test_listener = pipeline_package_complete.PipelinePackageCompleteProcessor(None)
        test_data = test_listener.process(example_message)

        assert test_data['msg_id'] == example_message['msg_id']
        assert test_data['topic'] == example_message['msg']['topic']
        assert test_data['build_id'] == example_message['msg']['build_id']
        assert test_data['build_url'] == example_message['msg']['build_url']
        assert test_data['package_url'] == example_message['msg']['package_url']
        assert test_data['branch'] == example_message['msg']['branch']
        assert test_data['ref'] == example_message['msg']['ref']
        assert test_data['rev'] == example_message['msg']['rev']
        assert test_data['repo'] == example_message['msg']['repo']
        assert test_data['namespace'] == example_message['msg']['namespace']
        assert test_data['username'] == example_message['msg']['username']
